VERSION 5.00
Begin VB.Form TypeIconsForm 
   Caption         =   "TypeIcons"
   ClientHeight    =   1710
   ClientLeft      =   1650
   ClientTop       =   1545
   ClientWidth     =   2145
   LinkTopic       =   "Form1"
   ScaleHeight     =   114
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   143
   Begin VB.ComboBox cboFileTypes 
      Height          =   315
      Left            =   0
      Sorted          =   -1  'True
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   0
      Width           =   2175
   End
   Begin VB.PictureBox LargeIconPicture 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   480
      Left            =   240
      ScaleHeight     =   32
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   32
      TabIndex        =   1
      Top             =   840
      Width           =   480
   End
   Begin VB.PictureBox SmallIconPicture 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   360
      Left            =   1320
      ScaleHeight     =   24
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   24
      TabIndex        =   0
      Top             =   840
      Width           =   360
   End
   Begin VB.Label SmallIconLabel 
      Height          =   255
      Left            =   1320
      TabIndex        =   3
      Top             =   480
      Width           =   855
   End
   Begin VB.Label LargeIconLabel 
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   480
      Width           =   855
   End
End
Attribute VB_Name = "TypeIconsForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type TypeIcon
    cbSize As Long
    picType As PictureTypeConstants
    hIcon As Long
End Type

Private Type CLSID
    id(16) As Byte
End Type

Private Const MAX_PATH = 260
Private Type SHFILEINFO
    hIcon As Long                      '  out: icon
    iIcon As Long                      '  out: icon index
    dwAttributes As Long               '  out: SFGAO_ flags
    szDisplayName As String * MAX_PATH '  out: display name (or path)
    szTypeName As String * 80          '  out: type name
End Type

Private Declare Function OleCreatePictureIndirect Lib "oleaut32.dll" (pDicDesc As TypeIcon, riid As CLSID, ByVal fown As Long, lpUnk As Object) As Long
Private Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" (ByVal pszPath As String, ByVal dwFileAttributes As Long, psfi As SHFILEINFO, ByVal cbFileInfo As Long, ByVal uFlags As Long) As Long

Private Const SHGFI_USEFILEATTRIBUTES = &H10             '  use passed dwFileAttribute
Private Const SHGFI_ICON = &H100
Private Const SHGFI_LARGEICON = &H0
Private Const SHGFI_SMALLICON = &H1

Private Const FILE_ATTRIBUTE_NORMAL = &H80

' Convert an icon handle into an IPictureDisp.
Private Function IconToPicture(hIcon As Long) As IPictureDisp
Dim cls_id As CLSID
Dim hRes As Long
Dim new_icon As TypeIcon
Dim lpUnk As IUnknown

    With new_icon
        .cbSize = Len(new_icon)
        .picType = vbPicTypeIcon
        .hIcon = hIcon
    End With
    With cls_id
        .id(8) = &HC0
        .id(15) = &H46
    End With
    hRes = OleCreatePictureIndirect(new_icon, _
        cls_id, 1, lpUnk)
    If hRes = 0 Then Set IconToPicture = lpUnk
End Function

Private Function GetTypeIcon(filename As String, icon_size As Long) As IPictureDisp
Dim index As Integer
Dim hIcon As Long
Dim item_num As Long
Dim icon_pic As IPictureDisp
Dim sh_info As SHFILEINFO

    SHGetFileInfo filename, FILE_ATTRIBUTE_NORMAL, sh_info, _
        Len(sh_info), SHGFI_USEFILEATTRIBUTES Or (SHGFI_ICON + icon_size)

    hIcon = sh_info.hIcon
    Set icon_pic = IconToPicture(hIcon)
    Set GetTypeIcon = icon_pic
End Function

Private Sub cboFileTypes_Click()
    On Error GoTo LoadPictureError

    SmallIconPicture.Picture = _
        GetTypeIcon(cboFileTypes.Text, SHGFI_SMALLICON)
    SmallIconLabel.Caption = _
        Format$(SmallIconPicture.ScaleWidth) & _
        "x" & _
        Format$(SmallIconPicture.ScaleHeight)

    LargeIconPicture.Picture = _
        GetTypeIcon(cboFileTypes.Text, SHGFI_LARGEICON)
    LargeIconLabel.Caption = _
        Format$(LargeIconPicture.ScaleWidth) & _
        "x" & _
        Format$(LargeIconPicture.ScaleHeight)
    
    Exit Sub

LoadPictureError:
    Beep
    Caption = "TypeIcons [Invalid picture]"
    Exit Sub
End Sub
Private Sub Form_Load()
    cboFileTypes.AddItem ".txt"
    cboFileTypes.AddItem ".doc"
    cboFileTypes.AddItem ".wmf"
    cboFileTypes.AddItem ".bmp"
    cboFileTypes.AddItem ".jpg"
    cboFileTypes.AddItem ".gif"
    cboFileTypes.AddItem ".frm"
    cboFileTypes.AddItem ".vbp"
    cboFileTypes.AddItem ".vbw"
    cboFileTypes.AddItem ".mdb"
    cboFileTypes.AddItem ".zip"

    cboFileTypes.ListIndex = 0
End Sub
